/*
	
 *************************************************************************************
 *                                                                                   *
 *               	MIRA - Multiple Infra Red Application                            *
 *                                                                                   *
 *************************************************************************************
 *                                                                                   *
 *  File:        	MIRA.h                                                           *
 *  Description:    Main header file contains basic configuration of MIRA units      *                                                                   *
 *                                                                                   *
 *  Author:   	 	Bc. Miroslav Skopal                                              *
 *  Date:     		23.5.2009                                                        *
 *  Platform: 		AVR (Tested on ATMega16 (fcpu = 16MHz)                           *
 *                                                                                   *
 *  License:		Licensed under GPLv2                                             *
 *                                                                                   *
 *  MIRA - Multiple InraRed Application Copyright (C) 2009 Miroslav Skopal           *
 *                                                                                   *
 *  This program is free software; you can redistribute it and/or                    *
 *  modify it under the terms of the GNU General Public License                      *
 *  as published by the Free Software Foundation; either version 2                   *
 *  of the License.                                                                  *
 *                                                                                   *
 *  This program is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 *  GNU General Public License for more details.                                     *
 *                                                                                   *
 *  You should have received a copy of the GNU General Public License                *
 *  along with this program; if not, write to the Free Software                      *
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
 *                                                                                   * 
 *************************************************************************************

*/

#ifndef _AVR_MIRA_H_
#define _AVR_MIRA_H_ 1
#include <avr/io.h>


// Zde prilinkujte vsechny soubory pro detekci protokolu na IR lince
#include "MIRA_RC5.h"
//#include "MIRA_RC6.h"
//#include "MIRA_NEC.h"
//#include "MIRA_JVC.h"



// Nastaveni hlavni callback funkce pro MIRA.h (parametr us obsahuje pocet mikrosekund
// mezi jednotlivymi IR pulzy)

#define MIRACallback RC5_Recieve(us)
//#define MIRACallback RC5_Recieve(us);RC6_Recieve(us)
//#define MIRACallback RC5_Recieve(us);RC6_Recieve(us);NEC_Recieve(us)


// zahookovani zobrazeni prijateho RC5 paketu
#include "MIRA_Sample.h"
#define RC5Recieve showRC5(RC5_ADDRESS >> 5, RC5_ADDRESS&0b00011111, RC5_COMMAND)


// Nakonfigurujte podle potreby
#define IR_TX_PIN 	PD5
#define IR_RX_PIN 	PD6
#define IR_TX_PORT 	PORTD
#define IR_RX_PORT 	PORTD
#define IR_TX_DDR	DDRD
#define IR_RX_DDR	DDRD


// makra pro zapinani a vypinani vysilaci diody
#define IR_TX_ON 	IR_TX_PORT |= _BV(IR_TX_PIN)
#define IR_TX_OFF 	IR_TX_PORT &= ~(_BV(IR_TX_PIN))

// tuto funkci je dobre zavolat pri startu mcu nebo pri zahajeni pouzivani IR komunikace
void MIRA_Init();

#endif

