#include "lcd.h"

void lcd_write_instruction(char instruction){
	
	// nastqaveni dat na zebrnici
	LCD_DATA = instruction;
	
	// Nastaveni pro zapis instrukce LCD_CTR_BUS, LCD_CTR_RS a LCD_CTR_CE je LO 
	LCD_CTRL &= ~(_BV(LCD_CTR_RS));

	// preklopeni LCD_CTR_CE do HI
	LCD_CTRL |= _BV(LCD_CTR_CE);
	
	// Podrzeni LCD_CTR_CE v HI po dobu 500ns
	_delay_us(0.5);

	// preklopeni LCD_CTR_CE do LO
	LCD_CTRL &= ~(_BV(LCD_CTR_CE));
	
}


void lcd_put_char(char ch){

	// nastqaveni dat na zebrnici
	LCD_DATA = ch;
	
	// Nastaveni pro zapis instrukce LCD_CTR_BUS, LCD_CTR_RS a LCD_CTR_CE je LO 
	LCD_CTRL |= _BV(LCD_CTR_RS);

	// preklopeni LCD_CTR_CE do HI
	LCD_CTRL |= _BV(LCD_CTR_CE);
	
	// Podrzeni LCD_CTR_CE v HI po dobu 500ns
	_delay_us(0.5);

	// preklopeni LCD_CTR_CE do LO
	LCD_CTRL &= ~(_BV(LCD_CTR_CE));
	
	_delay_us(46);

}

void lcd_put_string(char *string){
	while (*string) lcd_put_char(*string++);
}

// Move cursor to [x,y]
void lcd_goto(char x, char y){	
	lcd_write_instruction(0x80 | (y * 0x40 + x));
	_delay_us(46);
}

// Display CLEAR
void lcd_clear(){
	lcd_write_instruction(0x01);
	_delay_ms(1.7);
}


void lcd_init(){
	LCD_DATAR = 0xff;
	LCD_CTRLR |= (_BV(LCD_CTR_RS) | _BV(LCD_CTR_CE));
	
	LCD_DATA = 0x00;
	LCD_CTRL &= ~(_BV(LCD_CTR_RS));
	LCD_CTRL &= ~(_BV(LCD_CTR_CE));

	// cekani po zapnuti 
	char i;
	for (i=0;i<20;i++)
		_delay_ms(10);
		
	// Function Set
	lcd_write_instruction(0b00111100);
	_delay_us(50);

	// Display ON
	lcd_write_instruction(0b00001100);
	_delay_us(50);

	// Entry mode set
	lcd_write_instruction(0b00000110);
	_delay_us(50);

}
