/*
	
 *************************************************************************************
 *                                                                                   *
 *               				LCD - AT16052					                     *
 *                                                                                   *
 *************************************************************************************
 *                                                                                   *
 *  File:        	MIRA.h                                                           *
 *  Desctiption:                                                                     *
 *                                                                                   *
 *  Author:   	 	Bc. Miroslav Skopal                                              *
 *  Date:     		23.5.2009                                                        *
 *  Platform: 		AVR (Tested on ATMega16 (fcpu = 16MHz)                           *
 *                                                                                   *
 *  License:		Licensed under GPLv2                                             *
 *                                                                                   *
 *  MIRA - Multiple InraRed Application Copyright (C) 2009 Miroslav Skopal           *
 *                                                                                   *
 *  This program is free software; you can redistribute it and/or                    *
 *  modify it under the terms of the GNU General Public License                      *
 *  as published by the Free Software Foundation; either version 2                   *
 *  of the License.                                                                  *
 *                                                                                   *
 *  This program is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 *  GNU General Public License for more details.                                     *
 *                                                                                   *
 *  You should have received a copy of the GNU General Public License                *
 *  along with this program; if not, write to the Free Software                      *
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
 *                                                                                   * 
 *************************************************************************************

*/


#ifndef _LCD_H_
#define _LCD_H_ 1
#endif

#include <avr/io.h>
#include <util/delay.h>

#define LCD_DATA 	PORTA	// datova sbernice LCD
#define LCD_DATAR	DDRA	// registr pro urceni toku sbernice LCD
#define LCD_CTRL 	PORTC	// ridici sbernice LCD
#define LCD_CTRLR	DDRC	// registr pro urceni toku ridici sbernice

#define LCD_CTR_RS		PC0		// PIN R/S (instrukce/data)
#define LCD_CTR_CE		PC1		// PIN CE - chip enabled


void lcd_init();
void lcd_put_char(char ch);
void lcd_put_string(char *string);
void lcd_goto(char x, char y);
void lcd_clear();
